---

 source/built-ins.h     |    1 +
 source/highlightData.c |    4 ++--
 source/macro.c         |   15 +++++++++++++++
 source/menu.c          |   31 ++++++++++++++++++++++++++++++-
 source/nc.c            |   13 +++++++------
 source/nedit.h         |    1 +
 source/server.c        |   19 +++++++++++--------
 source/server_common.c |    5 ++---
 source/server_common.h |    3 +--
 source/window.c        |   22 +++++++++++++++-------
 source/windowTitle.c   |   11 +++++++++++
 source/windowTitle.h   |    1 +
 12 files changed, 97 insertions(+), 29 deletions(-)

diff --quilt old/source/menu.c new/source/menu.c
--- old/source/menu.c
+++ new/source/menu.c
@@ -56,6 +56,7 @@ static const char CVSID[] = "$Id: menu.c
 #include "regularExp.h"
 #include "hooks.h"
 #include "tabDragDrop.h"
+#include "server.h"
 #include "../util/getfiles.h"
 #include "../util/DialogF.h"
 #include "../util/misc.h"
@@ -440,6 +441,8 @@ static void setFontsAP(Widget w, XEvent 
     Cardinal *nArgs);
 static void setLanguageModeAP(Widget w, XEvent *event, String *args,
     Cardinal *nArgs);
+static void releaseClientAP(Widget w, XEvent *event, String *args,
+    Cardinal *nArgs);
 #ifdef SGI_CUSTOM
 static void shortMenusCB(Widget w, WindowInfo *window, caddr_t callData);
 static void addToToggleShortList(Widget w);
@@ -608,7 +611,8 @@ static XtActionsRec Actions[] = {
     {"set_use_tabs", setUseTabsAP},
     {"set_fonts", setFontsAP},
     {"begin_tab_drag", beginTabDragAP},
-    {"set_language_mode", setLanguageModeAP}
+    {"set_language_mode", setLanguageModeAP},
+    {"release_client", releaseClientAP}
 };
 
 /* List of previously opened files for File menu */
@@ -1302,6 +1306,12 @@ Widget CreateMenuBar(Widget parent, Wind
     btn = createMenuSeparator(menuPane, "sep1", SHORT);
     XtVaSetValues(btn, XmNuserData, PERMANENT_MENU_ITEM, NULL);
     
+    window->releaseClientItem = createMenuItem(menuPane, "releaseClient",
+            "Release Client", 'R', doActionCB, "release_client", SHORT);
+    XtSetSensitive(window->releaseClientItem, False);
+    btn = createMenuSeparator(menuPane, "sep2", SHORT);
+    XtVaSetValues(btn, XmNuserData, PERMANENT_MENU_ITEM, NULL);
+
     /* 
     ** Create "Help" pull down menu.
     */
@@ -4557,6 +4567,25 @@ static void setLanguageModeAP(Widget w, 
     }
 }
 
+static void releaseClientAP(Widget w, XEvent *event, String *args,
+    Cardinal *nArgs)
+{
+    WindowInfo *window = WidgetToWindow(w);
+
+    if (*nArgs != 0) {
+        fprintf(stderr, "nedit: invalid number of arguments for release_client\n");
+        return;
+    }
+
+    if (!IsServer)
+        return;
+
+    DeleteFileClosedProperty(window);
+    XtSetSensitive(window->releaseClientItem, window->fileClosedAtom != None);
+    UpdateWindowTitle(window);
+    RefreshTabState(window);
+}
+
 /*
 ** Same as AddSubMenu from libNUtil.a but 1) mnemonic is optional (NEdit
 ** users like to be able to re-arrange the mnemonics so they can set Alt
diff --quilt old/source/nedit.h new/source/nedit.h
--- old/source/nedit.h
+++ new/source/nedit.h
@@ -455,6 +455,7 @@ typedef struct _WindowInfo {
     Widget	closePaneItem;
     Widget	detachDocumentItem;
     Widget	moveDocumentItem;
+    Widget      releaseClientItem;
     Widget	contextMoveDocumentItem;
     Widget	contextDetachDocumentItem;
     Widget  	bgMenuUndoItem;
diff --quilt old/source/server.c new/source/server.c
--- old/source/server.c
+++ new/source/server.c
@@ -250,9 +250,7 @@ static Atom findFileClosedProperty(const
     
     if (!IsServer) return(None);
     
-    atom = CreateServerFileClosedAtom(GetPrefServerName(),
-                                      fullname,
-                                      True); /* don't create */
+    atom = CreateServerFileClosedAtom(GetPrefServerName(), fullname);
     return(atom);
 }
 
@@ -262,6 +260,9 @@ static void getFileClosedProperty(Window
     if (window->filenameSet) {
         window->fileClosedAtom = findFileClosedProperty(fullname);
     }
+    XtSetSensitive(window->releaseClientItem, window->fileClosedAtom != None);
+    UpdateWindowTitle(window);
+    RefreshTabState(window);
 }
 
 /* Delete the 'FileClosed' atom to inform nc that this file has
@@ -335,6 +336,7 @@ static void processServerCommandString(c
     int editFlags, stringLen = strlen(string);
     int lineNum, createFlag, readFlag, iconicFlag, lastIconic = 0, tabbed = -1;
     int fileLen, doLen, lmLen, geomLen, charsRead, itemsRead;
+    int clientWaits;
     WindowInfo *window, *lastFile = NULL;
     long currentDesktop = QueryCurrentDesktop(TheDisplay, 
        RootWindow(TheDisplay, DefaultScreen(TheDisplay)));
@@ -375,10 +377,10 @@ static void processServerCommandString(c
 	   command both followed by newlines.  This bit of code reads the
 	   header, and converts the newlines following the filename and do
 	   command to nulls to terminate the filename and doCommand strings */
-	itemsRead = sscanf(inPtr, "%d %d %d %d %d %d %d %d %d%n", &lineNum,
-		&readFlag, &createFlag, &iconicFlag, &tabbed, &fileLen,
-		&doLen, &lmLen, &geomLen, &charsRead);
-	if (itemsRead != 9)
+        itemsRead = sscanf(inPtr, "%d %d %d %d %d %d %d %d %d %d%n", &lineNum,
+                &readFlag, &createFlag, &iconicFlag, &tabbed, &clientWaits,
+                &fileLen, &doLen, &lmLen, &geomLen, &charsRead);
+        if (itemsRead != 10)
     	    goto readError;
 	inPtr += charsRead + 1;
         if (fileLen >= 0 && inPtr - string + fileLen > stringLen)
@@ -505,7 +507,8 @@ static void processServerCommandString(c
 	   command can do anything, including closing the window!) */
 	if (window != NULL) {
             deleteFileOpenProperty(window, requestname);
-            getFileClosedProperty(window, requestname);
+            if (clientWaits)
+                getFileClosedProperty(window, requestname);
 
 	    if (lineNum > 0)
 		SelectNumberedLine(window, lineNum);
diff --quilt old/source/window.c new/source/window.c
--- old/source/window.c
+++ new/source/window.c
@@ -2163,16 +2163,19 @@ void UpdateWindowTitle(const WindowInfo 
                                     window->lockReasons,
                                     window->fileChanged,
                                     window->transient,
+                                    window->fileClosedAtom != None,
                               format);
 
     if (strcmp(title, format) == 0)
         filename = title;
 
-    iconTitle = XtMalloc(strlen(filename) + 2); /* strlen("*")+1 */
+    iconTitle = XtMalloc(strlen(filename) + 3); /* strlen("*?")+1 */
 
     strcpy(iconTitle, filename);
     if (window->fileChanged && !window->transient)
         strcat(iconTitle, "*");
+    if (window->fileClosedAtom != None)
+        strcat(iconTitle, "?");
     XtVaSetValues(window->shell, XmNtitle, title, XmNiconName, iconTitle, NULL);
     
     /* If there's a find or replace dialog up in "Keep Up" mode, with a
@@ -3791,22 +3794,23 @@ int getTabPosition(Widget tab)
 void RefreshTabState(WindowInfo *win)
 {
     XmString s1, tipString;
-    char labelString[MAXPATHLEN];
+    char labelString[MAXPATHLEN+3];
     char *tag = XmFONTLIST_DEFAULT_TAG;
     unsigned char alignment;
-    const char *star = (win->fileChanged && !win->transient) ? "*" : "";
+    const char *changed = (win->fileChanged && !win->transient) ? "*" : "";
+    const char *waiting = (win->fileClosedAtom != None) ? "?" : "";
 
     /* Set tab label to document's filename. Position of
        "*" (modified) will change per label alignment setting */
     XtVaGetValues(win->tab, XmNalignment, &alignment, NULL);
     if (alignment != XmALIGNMENT_END) {
-       sprintf(labelString, "%s%s",
-               star,
+       sprintf(labelString, "%s%s%s",
+               waiting, changed,
                win->filename);
     } else {
-       sprintf(labelString, "%s%s",
+       sprintf(labelString, "%s%s%s",
                win->filename,
-               star);
+               changed, waiting);
     }
 
     /* Make the top document stand out a little more */
@@ -3969,6 +3973,10 @@ void RefreshMenuToggleStates(WindowInfo 
     	if (win->shell != window->shell)  
 	    break;
     XtSetSensitive(window->moveDocumentItem, win != NULL);
+
+    if (IsServer)
+        XtSetSensitive(window->releaseClientItem,
+                window->fileClosedAtom != None);
 }
 
 /*
diff --quilt old/source/built-ins.h new/source/built-ins.h
--- old/source/built-ins.h
+++ new/source/built-ins.h
@@ -134,3 +134,4 @@ MV(VERSION, version)
 MV(NEDIT_HOME, neditHome)
 MV(transient, transient)
 MV(macro_backtrace, macroBacktrace)
+MV(client_attached, clientAttached)
diff --quilt old/source/highlightData.c new/source/highlightData.c
--- old/source/highlightData.c
+++ new/source/highlightData.c
@@ -554,8 +554,8 @@ static char *DefaultPatternSets[] = {
         Built-in Misc Vars:\"(?<!\\Y)\\$(?:active_pane|calltip_ID|column|cursor|display_width|empty_array|file_name|file_path|language_mode|line|locked|max_font_width|min_font_width|modified|n_display_lines|n_panes|rangeset_list|read_only|selection_(?:start|end|left|right)|server_name|text_length|top_line|transient|VERSION|NEDIT_HOME)>\":::Identifier::\n\
         Built-in Pref Vars:\"(?<!\\Y)\\$(?:auto_indent|em_tab_dist|file_format|font_name|font_name_bold|font_name_bold_italic|font_name_italic|highlight_syntax|incremental_backup|incremental_search_line|make_backup_copy|match_syntax_based|overtype_mode|show_line_numbers|show_matching|statistics_line|tab_dist|use_tabs|wrap_margin|wrap_text)>\":::Identifier2::\n\
         Built-in Special Vars:\"(?<!\\Y)\\$(?:args|[1-9]|list_dialog_button|macro_name|n_args|read_status|search_end|shell_cmd_status|string_dialog_button|sub_sep|macro_backtrace)>\":::String1::\n\
-        Built-in Subrs:\"<(?:args|append_file|beep|call|calltip|clipboard_to_string|define|dialog|eval|filename_dialog|dict_(?:insert|complete|save|append|is_element)|e_print|escape_literal|focus_window|get_character|get_matching|get_pattern_(by_name|at_pos)|get_range|get_selection|get_style_(by_name|at_pos)|getenv|highlight_calltip_line|kill_calltip|length|list_dialog|max|min|n_args|rangeset_(?:add|create|destroy|get_by_name|includes|info|invert|range|set_color|set_mode|set_name|subtract)|read_file|replace_in_string|replace_range|replace_selection|replace_substring|search|search_string|select|select_rectangle|set_cursor_pos|set_transient|set_window_title|shell_command|split|string_compare|string_dialog|string_to_clipboard|substring|t_print|timer_(?:add|remove)|to_(?:column|line|pos)|tolower|toupper|valid_number|write_file)(?=\\s*\\()\":::Subroutine::\n\
-        Menu Actions:\"<(?:new(?:_tab|_opposite)?|open|open-dialog|open_dialog|open-selected|open_selected|close|save|save-as|save_as|save-as-dialog|save_as_dialog|revert-to-saved|revert_to_saved|revert_to_saved_dialog|include-file|include_file|include-file-dialog|include_file_dialog|load-macro-file|load_macro_file|load-macro-file-dialog|load_macro_file_dialog|load-tags-file|load_tags_file|load-tags-file-dialog|load_tags_file_dialog|unload_tags_file|load_tips_file|load_tips_file_dialog|unload_tips_file|print|print-selection|print_selection|exit|undo|redo|delete|select-all|select_all|shift-left|shift_left|shift-left-by-tab|shift_left_by_tab|shift-right|shift_right|shift-right-by-tab|shift_right_by_tab|find|find-dialog|find_dialog|find-again|find_again|find-selection|find_selection|find_incremental|start_incremental_find|replace|replace-dialog|replace_dialog|replace-all|replace_all|replace-in-selection|replace_in_selection|replace-again|replace_again|replace_find|replace_find_same|replace_find_again|goto-line-number|goto_line_number|goto-line-number-dialog|goto_line_number_dialog|goto-selected|goto_selected|mark|mark-dialog|mark_dialog|goto-mark|goto_mark|goto-mark-dialog|goto_mark_dialog|match|select_to_matching|goto_matching|find-definition|find_definition|show_tip|split-pane|split_pane|close-pane|close_pane|detach_document(?:_dialog)?|move_document_dialog|(?:next|previous|last)_document|uppercase|lowercase|fill-paragraph|fill_paragraph|control-code-dialog|control_code_dialog|filter-selection-dialog|filter_selection_dialog|filter-selection|filter_selection|execute-command|execute_command|execute-command-dialog|execute_command_dialog|execute-command-line|execute_command_line|shell-menu-command|shell_menu_command|macro-menu-command|macro_menu_command|bg_menu_command|post_window_bg_menu|post_tab_context_menu|beginning-of-selection|beginning_of_selection|end-of-selection|end_of_selection|repeat_macro|repeat_dialog|raise_window|focus_pane|set_statistics_line|set_incremental_search_line|set_show_line_numbers|set_auto_indent|set_wrap_text|set_wrap_margin|set_highlight_syntax|set_make_backup_copy|set_incremental_backup|set_show_matching|set_match_syntax_based|set_overtype_mode|set_locked|set_tab_dist|set_em_tab_dist|set_use_tabs|set_fonts|set_language_mode)(?=\\s*\\()\":::Subroutine::\n\
+        Built-in Subrs:\"<(?:args|append_file|beep|call|calltip|client_attached|clipboard_to_string|define|dialog|eval|filename_dialog|dict_(?:insert|complete|save|append|is_element)|e_print|escape_literal|focus_window|get_character|get_matching|get_pattern_(by_name|at_pos)|get_range|get_selection|get_style_(by_name|at_pos)|getenv|highlight_calltip_line|kill_calltip|length|list_dialog|max|min|n_args|rangeset_(?:add|create|destroy|get_by_name|includes|info|invert|range|set_color|set_mode|set_name|subtract)|read_file|replace_in_string|replace_range|replace_selection|replace_substring|search|search_string|select|select_rectangle|set_cursor_pos|set_transient|set_window_title|shell_command|split|string_compare|string_dialog|string_to_clipboard|substring|t_print|timer_(?:add|remove)|to_(?:column|line|pos)|tolower|toupper|valid_number|write_file)(?=\\s*\\()\":::Subroutine::\n\
+        Menu Actions:\"<(?:new(?:_tab|_opposite)?|open|open-dialog|open_dialog|open-selected|open_selected|close|save|save-as|save_as|save-as-dialog|save_as_dialog|revert-to-saved|revert_to_saved|revert_to_saved_dialog|include-file|include_file|include-file-dialog|include_file_dialog|load-macro-file|load_macro_file|load-macro-file-dialog|load_macro_file_dialog|load-tags-file|load_tags_file|load-tags-file-dialog|load_tags_file_dialog|unload_tags_file|load_tips_file|load_tips_file_dialog|unload_tips_file|print|print-selection|print_selection|exit|undo|redo|delete|select-all|select_all|shift-left|shift_left|shift-left-by-tab|shift_left_by_tab|shift-right|shift_right|shift-right-by-tab|shift_right_by_tab|find|find-dialog|find_dialog|find-again|find_again|find-selection|find_selection|find_incremental|start_incremental_find|replace|replace-dialog|replace_dialog|replace-all|replace_all|replace-in-selection|replace_in_selection|replace-again|replace_again|replace_find|replace_find_same|replace_find_again|goto-line-number|goto_line_number|goto-line-number-dialog|goto_line_number_dialog|goto-selected|goto_selected|mark|mark-dialog|mark_dialog|goto-mark|goto_mark|goto-mark-dialog|goto_mark_dialog|match|select_to_matching|goto_matching|find-definition|find_definition|show_tip|split-pane|split_pane|close-pane|close_pane|detach_document(?:_dialog)?|move_document_dialog|(?:next|previous|last)_document|uppercase|lowercase|fill-paragraph|fill_paragraph|control-code-dialog|control_code_dialog|filter-selection-dialog|filter_selection_dialog|filter-selection|filter_selection|execute-command|execute_command|execute-command-dialog|execute_command_dialog|execute-command-line|execute_command_line|shell-menu-command|shell_menu_command|macro-menu-command|macro_menu_command|bg_menu_command|post_window_bg_menu|post_tab_context_menu|beginning-of-selection|beginning_of_selection|end-of-selection|end_of_selection|repeat_macro|repeat_dialog|raise_window|focus_pane|set_statistics_line|set_incremental_search_line|set_show_line_numbers|set_auto_indent|set_wrap_text|set_wrap_margin|set_highlight_syntax|set_make_backup_copy|set_incremental_backup|set_show_matching|set_match_syntax_based|set_overtype_mode|set_locked|set_tab_dist|set_em_tab_dist|set_use_tabs|set_fonts|set_language_mode|release_client)(?=\\s*\\()\":::Subroutine::\n\
         Text Actions:\"<(?:self-insert|self_insert|grab-focus|grab_focus|extend-adjust|extend_adjust|extend-start|extend_start|extend-end|extend_end|secondary-adjust|secondary_adjust|secondary-or-drag-adjust|secondary_or_drag_adjust|secondary-start|secondary_start|secondary-or-drag-start|secondary_or_drag_start|process-bdrag|process_bdrag|move-destination|move_destination|move-to|move_to|move-to-or-end-drag|move_to_or_end_drag|end_drag|copy-to|copy_to|copy-to-or-end-drag|copy_to_or_end_drag|exchange|process-cancel|process_cancel|paste-clipboard|paste_clipboard|copy-clipboard|copy_clipboard|cut-clipboard|cut_clipboard|copy-primary|copy_primary|cut-primary|cut_primary|newline|newline-and-indent|newline_and_indent|newline-no-indent|newline_no_indent|delete-selection|delete_selection|delete-previous-character|delete_previous_character|delete-next-character|delete_next_character|delete-previous-word|delete_previous_word|delete-next-word|delete_next_word|delete-to-start-of-line|delete_to_start_of_line|delete-to-end-of-line|delete_to_end_of_line|forward-character|forward_character|backward-character|backward_character|key-select|key_select|process-up|process_up|process-down|process_down|process-shift-up|process_shift_up|process-shift-down|process_shift_down|process-home|process_home|forward-word|forward_word|backward-word|backward_word|forward-paragraph|forward_paragraph|backward-paragraph|backward_paragraph|beginning-of-line|beginning_of_line|end-of-line|end_of_line|beginning-of-file|beginning_of_file|end-of-file|end_of_file|next-page|next_page|previous-page|previous_page|page-left|page_left|page-right|page_right|toggle-overstrike|toggle_overstrike|scroll-up|scroll_up|scroll-down|scroll_down|scroll_left|scroll_right|scroll-to-line|scroll_to_line|select-all|select_all|select_word|deselect-all|deselect_all|focusIn|focusOut|process-return|process_return|process-tab|process_tab|insert-string|insert_string|mouse_pan)(?=\\s*\\()\":::Subroutine::\n\
         Macro Hooks:\"<(?:(?:pre|post)_(?:open|save)|cursor_moved|modified|(?:losing_)?focus|language_mode)_hook(?=\\s*\\()\":::Subroutine1::\n\
         Keyword:\"<(?:break|case|continue|default|define|delete|do|else|finally|for|if|in|readonly|return|switch|typeof|while)>\":::Keyword::\n\
diff --quilt old/source/macro.c new/source/macro.c
--- old/source/macro.c
+++ new/source/macro.c
@@ -7216,6 +7216,21 @@ static int macroBacktraceMV(WindowInfo *
     return GetBacktrace(result, errMsg);
 }
 
+static int clientAttachedMV(WindowInfo *window, DataValue *argList,
+      int nArgs, DataValue *result, char **errMsg)
+{
+    result->tag   = INT_TAG;
+    result->val.n = 0;
+
+    /* if we don't run in server mode, return always false */
+    if (!IsServer)
+        return True;
+
+    result->val.n = window->fileClosedAtom != None;
+
+    return True;
+}
+
 static int wrongNArgsErr(char **errMsg)
 {
     *errMsg = "Wrong number of arguments to function %s";
diff --quilt old/source/nc.c new/source/nc.c
--- old/source/nc.c
+++ new/source/nc.c
@@ -227,8 +227,7 @@ static void createWaitProperties(void)
             fileListHead.waitForCloseCount++;
             item->waitForFileClosedAtom =
                       CreateServerFileClosedAtom(Preferences.serverName,
-                                                 item->path,
-                                                 False);
+                                                 item->path);
             setPropertyValue(item->waitForFileClosedAtom);
         }
     }
@@ -781,9 +780,10 @@ static void parseCommandLine(int argc, c
 		}
 	    
                 /* See below for casts */
-                sprintf(outPtr, "%d %d %d %d %d %ld %ld %ld %ld\n"
+                sprintf(outPtr, "%d %d %d %d %d %d %ld %ld %ld %ld\n"
                                 "%s%s\n%s\n%s\n%s\n%n",
                         lineNum, read, create, iconic, tabbed,
+                        !!Preferences.waitForClose,
                         filePrefixLen + (long) strlen(path),
 			(long) strlen(toDoCommand), (long) strlen(langMode), 
                         (long) strlen(geometry),
@@ -826,8 +826,8 @@ static void parseCommandLine(int argc, c
                The "long" cast on strlen() is necessary because size_t
                is 64 bit on Alphas, and 32-bit on most others.  There is
                no printf format specifier for "size_t", thanx, ANSI. */
-    	    sprintf(outPtr, "%d %d %d %d %d %ld %ld %ld %ld\n%n", lineNum,
-                    read, create, iconic, isTabbed,
+            sprintf(outPtr, "%d %d %d %d %d %d %ld %ld %ld %ld\n%n", lineNum,
+                    read, create, iconic, isTabbed, !!Preferences.waitForClose,
                     filePrefixLen + (long) strlen(path),
 		    (long) strlen(toDoCommand), (long) strlen(langMode),
 		    (long) strlen(geometry), &charsWritten);
@@ -891,7 +891,7 @@ static void parseCommandLine(int argc, c
         /* TODO: what about other platforms? */
 #endif /* VMS */
 
-        sprintf(outPtr, "0 0 %d %d %d %ld %ld %ld %ld\n%n",
+        sprintf(outPtr, "0 0 %d %d %d 0 %ld %ld %ld %ld\n%n",
                 doInNew, iconic, tabbed, -(filePrefixLen + length),
                 (long) strlen(toDoCommand), (long) strlen(langMode),
                 (long) strlen(geometry), &charsWritten);
@@ -1093,3 +1093,4 @@ static void printNcVersion(void ) {
                   COMPILE_OS, COMPILE_MACHINE, COMPILE_COMPILER,
                   __DATE__, __TIME__);
 }
+
diff --quilt old/source/windowTitle.c new/source/windowTitle.c
--- old/source/windowTitle.c
+++ new/source/windowTitle.c
@@ -193,6 +193,7 @@ static void compressWindowTitle(char *ti
 
                 /* remove empty paranthesis pairs */
                 case '(':
+                    sourcePtr = removeSequence(sourcePtr, ' ');
                     if (*sourcePtr == ')') {
                         modified = True;
                         sourcePtr++;
@@ -202,6 +203,7 @@ static void compressWindowTitle(char *ti
                     break;
 
                 case '[':
+                    sourcePtr = removeSequence(sourcePtr, ' ');
                     if (*sourcePtr == ']') {
                         modified = True;
                         sourcePtr++;
@@ -211,6 +213,7 @@ static void compressWindowTitle(char *ti
                     break;
 
                 case '{':
+                    sourcePtr = removeSequence(sourcePtr, ' ');
                     if (*sourcePtr == '}') {
                         modified = True;
                         sourcePtr++;
@@ -250,6 +253,7 @@ static void compressWindowTitle(char *ti
             of leading hosts components to dispaly.
 **  %S    : file status
 **  %u    : user name
+**  %w    : "waiting" if a client is waiting for the closure of this document
 **
 **  if the ClearCase view tag and server name are identical, only the first one
 **  specified in the formatting string will be displayed. 
@@ -263,6 +267,7 @@ char *FormatWindowTitle(const char* file
                         int lockReasons,
                         int fileChanged,
                         int transient,
+                        int clientWaits,
                         const char* titleFormat)
 {
     static char title[WINDOWTITLE_MAX_LEN];
@@ -410,6 +415,11 @@ char *FormatWindowTitle(const char* file
                     titlePtr = safeCharAdd(titlePtr, titleEnd, '%');
                     break;
                    
+                case 'w': /* client is waiting */
+                    if (isServer && clientWaits)
+                        titlePtr = safeStrCpy(titlePtr, titleEnd, "waiting");
+                    break;
+
 		case '*': /* short file status ? */
                     fileStatusPresent = True;
 		    if (*titleFormat && *titleFormat == 'S')
@@ -593,6 +603,7 @@ static void formatChangedCB(Widget w, Xt
                   etDialog.lockReasons,
                   XmToggleButtonGetState(etDialog.oFileChangedW),
                   XmToggleButtonGetState(etDialog.oTransientW),
+                  False,
                   format);
     XtFree(format);
     XmTextFieldSetString(etDialog.previewW, title);
diff --quilt old/source/windowTitle.h new/source/windowTitle.h
--- old/source/windowTitle.h
+++ new/source/windowTitle.h
@@ -43,6 +43,7 @@ char *FormatWindowTitle(const char* file
                         int lockReasons,
                         int fileChanged,
                         int transient,
+                        int clientWaits,
                         const char* titleFormat);
                         
 void EditCustomTitleFormat(WindowInfo *window);
diff --quilt old/source/server_common.c new/source/server_common.c
--- old/source/server_common.c
+++ new/source/server_common.c
@@ -114,8 +114,7 @@ Atom CreateServerFileOpenAtom(const char
 }
 
 Atom CreateServerFileClosedAtom(const char *serverName, 
-	                        const char *path,
-                                Bool only_if_exist)
+	                        const char *path)
 {
     char propName[10+1+
                   NEDIT_VERSION_STRING_LEN+1+
@@ -130,7 +129,7 @@ Atom CreateServerFileClosedAtom(const ch
 
     sprintf(propName, "NEDIT_%s_FILE_%s_%s_%s_%s_WF_CLOSED",
             NEDIT_VERSION_STRING, hostName, userName, serverName, path);
-    atom = XInternAtom(TheDisplay, propName, only_if_exist);
+    atom = XInternAtom(TheDisplay, propName, False);
     return(atom);
 }
 
diff --quilt old/source/server_common.h new/source/server_common.h
--- old/source/server_common.h
+++ new/source/server_common.h
@@ -43,8 +43,7 @@ void CreateServerPropertyAtoms(const cha
 Atom CreateServerFileOpenAtom(const char *serverName, 
 	                      const char *path);
 Atom CreateServerFileClosedAtom(const char *serverName, 
-	                        const char *path,
-                                Bool only_if_exists);
+	                        const char *path);
 void DeleteServerFileAtoms(const char* serverName, Window rootWindow);
 
 #endif /* NEDIT_SERVER_COMMON_H_INCLUDED */
